#include<semaphore.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>
#include <stdint.h>
#include <limits.h>
#include<fcntl.h> 
#include<unistd.h>
#include<string.h>
#include<sys/stat.h>
#include <sys/types.h>

int *fds;
int setSize=2;
int *readCounters;
sem_t *mutex;
sem_t *readerLocks;
sem_t x,y;
pthread_t tid;
pthread_t writerthreads[100],readerthreads[100];
int readercount = 0;
int modulus(char *num, int size, int divisor) {
  int rem = 0;
 
  while (size-- > 0) {
    rem = ((UCHAR_MAX + 1)*rem + *num) % divisor;
    num++;
  }
  return rem;
}
void file_del(char *key)
{   
    int index=modulus(key,256,setSize);
    sem_wait(&mutex[index]);
    FILE * fp;
    char * line = NULL;
    size_t len = 0;
    int read;

    fp = fdopen(fds[index], "a+");
    if (fp == NULL)
       printf("\n[Invalid file]\n");
    int position=0;
    while ((read = getline(&line, &len, fp)) != -1)
    {
        
        if(strstr(line,key)!=NULL && strstr(strstr(line,key),":")!=NULL)
        {
            
            fseek(fp,position,SEEK_SET);
           
            
            break;
        }
        else
        {
            position+=len;
        }
        
    }
   //fclose(fp);
    if (line)
        free(line);
    sem_wait(&readerLocks[index]);
    readercount--;
    if(readercount==0)
    {
        sem_post(&mutex[index]);
    }
    sem_post(&readerLocks[index]);
}
void file_get(char *key,char *value)
{   
    
    int index=modulus(key,256,setSize);
    sem_wait(&readerLocks[index]);
    readCounters[index]++;
    if(readCounters[index]==1)
        sem_wait(&mutex[index]);
    sem_post(&readerLocks[index]);
    FILE * fp;
    char * line = NULL;
    size_t len = 0;
    int read;

    fp = fdopen(fds[index], "r");
    if (fp == NULL)
       printf("\n[Invalid file]\n");

    while ((read = getline(&line, &len, fp)) != -1)
    {
        if(strstr(line,key)!=NULL && strstr(strstr(line,key),":")!=NULL)
        {
            snprintf(value,sizeof((strchr(line,':')+1)),"%s",(strchr(line,':')+1));
        }   
    }
    fclose(fp);
    if (line)
        free(line);
    sem_wait(&readerLocks[index]);
    readercount--;
    if(readercount==0)
    {
        sem_post(&mutex[index]);
    }
    sem_post(&readerLocks[index]);
}
void file_put(char *key,char *value)
{
    int index=modulus(key,256,setSize);
    sem_wait(&mutex[index]);
    printf("\n[Write to File: %d]\n",index);
    char line[514];
    int i=0;
    for(i=0;i<256;i++)
    {
        if(key[i]!='\0')
        {
            line[i]=key[i];
        }
        else
        {
            break;
        }    
    }
    int k=0;
    line[i++]=':';
    for(;i<512;i++)
    {
       if(value[k]!='\0')
        {
            line[i]=value[k++];
        }
        else
        {
            break;
        }    
    }
    line[i]='\n';
    if(write(fds[index],line,strlen(line))<0)
    {
        printf("\n[Unable to Write to File]\n");
    }
    
    sem_post(&mutex[index]);
}


int main()
{
    /*
        define the array of file descriptors  depending on the prefix 
        define the array of readCount as well as the semaphore (read x and write y) for the same
        PUT,DEL would use write lock 
        GET would use read lock
        each write should return the line number

    */
    int n2=0;
    char key[256]="24";
    char value[256]="value";
    fds=(int *)malloc(sizeof(int)*setSize);
    readCounters=(int *)malloc(sizeof(int)*setSize);
    readerLocks=(sem_t *)malloc(sizeof(sem_t)*setSize);
    mutex=(sem_t *)malloc(sizeof(sem_t)*setSize);
    int i=0;
    char fileName[setSize+20];
    for(i=0;i<setSize;i++)
    {
        snprintf(fileName,sizeof(fileName),"File%d.txt",i);
        fds[i]=open(fileName, O_CREAT|O_RDWR|O_APPEND,S_IRWXU);
        if(fds[i]<0)
        {
            printf("\n[Unable to Open File%d.txt]\n",i);
        }
        sem_init(&readerLocks[i],0,1);
        sem_init(&mutex[i],0,1);
        readCounters[i]=0;
    }
    //file_put(key,value);
    value[0]='\0';
   // file_get(key,value);
   /*  for(i=0;i<setSize-1;i++)
    {
        close(fds[i]);
    } */
   // printf("main vala hai ye!!");
  //  puts(value);
   file_del(key);
    /*
    printf("%u",modulus(key,256,3));
    //scanf("%d",&n2);
    printf("\n");
    int n1[n2];
    sem_init(&x,0,1);
    sem_init(&y,0,1);
    for(i=0;i<n2;i++)
    {
        pthread_create(&writerthreads[i],NULL,reader,NULL);
        pthread_create(&readerthreads[i],NULL,writer,NULL);
    }
    for(i=0;i<n2;i++)
    {
        pthread_join(writerthreads[i],NULL);
        pthread_join(readerthreads[i],NULL);
    }
    */

}
